// DlgShowEvent.cpp : implementation file
//

#include "stdafx.h"
#include "TrackDemo.h"
#include "DlgShowEvent.h"


// CDlgShowEvent dialog

IMPLEMENT_DYNAMIC(CDlgShowEvent, CDialog)

CDlgShowEvent::CDlgShowEvent(CWnd* pParent /*=NULL*/)
  : CDialog(CDlgShowEvent::IDD, pParent)
  , m_name(_T(""))
  , m_serial(_T(""))
  , m_time(_T(""))
  , m_mode(_T(""))
  , m_latitude(_T(""))
  , m_longitude(_T(""))
  , m_speed(_T(""))
  , m_direction(_T(""))
  , m_supply(_T(""))
{
}

CDlgShowEvent::~CDlgShowEvent()
{
}

void CDlgShowEvent::DoDataExchange(CDataExchange* pDX)
{
  CDialog::DoDataExchange(pDX);
  DDX_Text(pDX, IDC_NAME, m_name);
  DDX_Text(pDX, IDC_TIME, m_time);
  DDX_Text(pDX, IDC_GPSMODE, m_mode);
  DDX_Text(pDX, IDC_LATITUDE, m_latitude);
  DDX_Text(pDX, IDC_LONGITUDE, m_longitude);
  DDX_Text(pDX, IDC_SPEED, m_speed);
  DDX_Text(pDX, IDC_DIRECTION, m_direction);
  DDX_Text(pDX, IDC_SUPPLY, m_supply);
  DDX_Text(pDX, IDC_SERIAL, m_serial);
}


BEGIN_MESSAGE_MAP(CDlgShowEvent, CDialog)
  ON_BN_CLICKED(IDC_GOOGLEMAPS, &CDlgShowEvent::OnGoogleMaps)
END_MESSAGE_MAP()


// CDlgShowEvent message handlers

BOOL CDlgShowEvent::OnInitDialog()
{
  // Default
  CDialog::OnInitDialog();

  // Position?
  if (m_latitude == _T("N/A")) GetDlgItem(IDC_GOOGLEMAPS)->EnableWindow(FALSE);

  // Completed
  return TRUE;
}

void CDlgShowEvent::OnGoogleMaps()
{
  // Var
  CString link(_T("http://maps.google.com/maps?q="));
  int     pos;

  // Insert latitude
  pos   = m_latitude.GetLength() - 6;
  link += m_latitude.Left(pos);
  link += _T("+");
  link += m_latitude.Mid(pos, 2);
  link += _T(".");
  link += m_latitude.Mid(pos+2);
  link += _T("+");

  // Insert longitude
  pos   = m_longitude.GetLength() - 6;
  link += m_longitude.Left(pos);
  link += _T("+");
  link += m_longitude.Mid(pos, 2);
  link += _T(".");
  link += m_longitude.Mid(pos+2);
  link += _T("+");

  // Insert text
  link += _T("(");
  link += m_time;
  link += _T(" => ");
  pos   = m_name.Find(_T("from"));
  if (pos > 0) {
    link += m_name.Left(pos);
    link += _T("%2B");
    link += m_name.Mid(pos);
  } else {
    link += m_name;
  }
  link += _T(")");

  // Open browser
  ShellExecute(NULL, _T("open"), link, NULL, NULL, SW_SHOWNORMAL);
}
