// PageActions.cpp : implementation file
//

#include "stdafx.h"
#include "TrackDemo.h"
#include "PageActions.h"
#include "..\VSMSGW\VSMSGW.h"


// CPageActions dialog

IMPLEMENT_DYNAMIC(CPageActions, CPropertyPage)

CPageActions::CPageActions()
  : CPropertyPage(CPageActions::IDD)
  , m_din_hold(0)
  , m_din_on(FALSE)
  , m_din_off(FALSE)
  , m_fence_lat(0)
  , m_fence_lon(0)
  , m_fence_dist(0)
  , m_fence_enter(FALSE)
  , m_fence_exit(FALSE)
  , m_pos_freq(0)
  , m_power_int(FALSE)
  , m_power_ext(FALSE)
  , m_speed_limit(0)
  , m_speed_hold(0)
  , m_speed_falling(FALSE)
  , m_speed_raising(FALSE)
  , m_Index(0)
{
}

CPageActions::~CPageActions()
{
}

void CPageActions::DoDataExchange(CDataExchange* pDX)
{
  CPropertyPage::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_TAB, c_tab);
  DDX_Text(pDX, IDC_TIMEOUT, m_din_hold);
  DDX_Check(pDX, IDC_ON, m_din_on);
  DDX_Check(pDX, IDC_OFF, m_din_off);
  DDX_Text(pDX, IDC_LATITUDE, m_fence_lat);
  DDX_Text(pDX, IDC_LONGITUDE, m_fence_lon);
  DDX_Text(pDX, IDC_DISTANCE, m_fence_dist);
  DDX_Check(pDX, IDC_ENTER, m_fence_enter);
  DDX_Check(pDX, IDC_EXIT, m_fence_exit);
  DDX_Text(pDX, IDC_POSFREQ, m_pos_freq);
  DDX_Check(pDX, IDC_INTERNAL, m_power_int);
  DDX_Check(pDX, IDC_EXTERNAL, m_power_ext);
  DDX_Text(pDX, IDC_SPEED, m_speed_limit);
  DDX_Text(pDX, IDC_SPEEDHOLD, m_speed_hold);
  DDX_Check(pDX, IDC_FALLING, m_speed_falling);
  DDX_Check(pDX, IDC_RAISING, m_speed_raising);
}


BEGIN_MESSAGE_MAP(CPageActions, CPropertyPage)
  ON_BN_CLICKED(IDC_SET, &CPageActions::OnInputSet)
  ON_BN_CLICKED(IDC_SET_GEOFENCE, &CPageActions::OnSetGeofence)
  ON_BN_CLICKED(IDC_SET_POSFREQ, &CPageActions::OnSetPosfreq)
  ON_BN_CLICKED(IDC_SET_POWER, &CPageActions::OnSetPower)
  ON_BN_CLICKED(IDC_SET_MOVEMENT, &CPageActions::OnSetSpeed)
  ON_NOTIFY(TCN_SELCHANGE, IDC_TAB, &CPageActions::OnTcnSelchangeTab)
END_MESSAGE_MAP()


// CPageActions message handlers

BOOL CPageActions::OnInitDialog()
{
  // Default
  CPropertyPage::OnInitDialog();

  // Initialize controls
  c_tab.InsertItem(0, _T("DIN1"));
  c_tab.InsertItem(1, _T("DIN2"));
  c_tab.InsertItem(2, _T("DIN3"));
  c_tab.InsertItem(3, _T("DIN4"));
  c_tab.InsertItem(4, _T("DIN5"));
  ((CEdit*)GetDlgItem(IDC_POSFREQ))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_SPEED))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_SPEEDHOLD))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_LATITUDE))->LimitText(9);
  ((CEdit*)GetDlgItem(IDC_LONGITUDE))->LimitText(9);
  ((CEdit*)GetDlgItem(IDC_DISTANCE))->LimitText(5);
  ((CEdit*)GetDlgItem(IDC_TIMEOUT))->LimitText(5);

  // Retreive saved values from registry
  m_Entry[0].HoldTime = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital1.HoldTime"), 0);
  m_Entry[0].on       = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital1.Low"), 0);
  m_Entry[0].off      = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital1.High"), 0);
  m_Entry[1].HoldTime = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital2.HoldTime"), 0);
  m_Entry[1].on       = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital2.Low"), 0);
  m_Entry[1].off      = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital2.High"), 0);
  m_Entry[2].HoldTime = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital3.HoldTime"), 0);
  m_Entry[2].on       = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital3.Low"), 0);
  m_Entry[2].off      = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital3.High"), 0);
  m_Entry[3].HoldTime = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital4.HoldTime"), 0);
  m_Entry[3].on       = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital4.Low"), 0);
  m_Entry[3].off      = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital4.High"), 0);
  m_Entry[4].HoldTime = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital5.HoldTime"), 0);
  m_Entry[4].on       = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital5.Low"), 0);
  m_Entry[4].off      = AfxGetApp()->GetProfileInt(_T("Event\\Input"), _T("digital5.High"), 0);
  m_fence_lat         = AfxGetApp()->GetProfileInt(_T("Event\\Fence"), _T("Latitude"), 0);
  m_fence_lon         = AfxGetApp()->GetProfileInt(_T("Event\\Fence"), _T("Longitude"), 0);
  m_fence_dist        = AfxGetApp()->GetProfileInt(_T("Event\\Fence"), _T("Distance"), 0);
  m_fence_enter       = AfxGetApp()->GetProfileInt(_T("Event\\Fence"), _T("Enter"), 0);
  m_fence_exit        = AfxGetApp()->GetProfileInt(_T("Event\\Fence"), _T("Exit"), 0);
  m_pos_freq          = AfxGetApp()->GetProfileInt(_T("Event\\Position"), _T("Frequency"), 0);
  m_power_int         = AfxGetApp()->GetProfileInt(_T("Event\\Power"), _T("Internal"), 0);
  m_power_ext         = AfxGetApp()->GetProfileInt(_T("Event\\Power"), _T("External"), 0);
  m_speed_limit       = AfxGetApp()->GetProfileInt(_T("Event\\Speed"), _T("Limit"), 0);
  m_speed_hold        = AfxGetApp()->GetProfileInt(_T("Event\\Speed"), _T("HoldTime"), 0);
  m_speed_falling     = AfxGetApp()->GetProfileInt(_T("Event\\Speed"), _T("Falling"), 0);
  m_speed_raising     = AfxGetApp()->GetProfileInt(_T("Event\\Speed"), _T("Raising"), 0);

  // Completed
  VarToView(0);
  return TRUE;
}

void CPageActions::OnInputSet()
{
  // Var
  CString EntName;
  FrameSetInput req;
  int          rc;

  // Save old
  ViewToVar(m_Index);

  // Update Registry
  EntName.Format(_T("digital%d."), m_Index + 1);
  AfxGetApp()->WriteProfileInt(_T("Event\\Input"), EntName + _T("HoldTime"), m_Entry[m_Index].HoldTime);
  AfxGetApp()->WriteProfileInt(_T("Event\\Input"), EntName + _T("Low"),      m_Entry[m_Index].on);
  AfxGetApp()->WriteProfileInt(_T("Event\\Input"), EntName + _T("High"),     m_Entry[m_Index].off);

  // Create command VSMS
  req.Command   = 0x03;
  req.Input     = m_Index + 1;
  req.Duration  = m_Entry[m_Index].HoldTime;
  req.Low       = m_Entry[m_Index].off;
  req.High      = m_Entry[m_Index].on;

  // Send VSMS
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set input event"), MB_OK|MB_ICONWARNING);
}

void CPageActions::OnSetGeofence()
{
  // Var
  CString EntName;
  FrameSetGeoFence req;
  int          rc;

  // Update Registry
  UpdateData(TRUE);
  AfxGetApp()->WriteProfileInt(_T("Event\\Fence"), _T("Latitude"),  m_fence_lat);
  AfxGetApp()->WriteProfileInt(_T("Event\\Fence"), _T("Longitude"), m_fence_lon);
  AfxGetApp()->WriteProfileInt(_T("Event\\Fence"), _T("Distance"),  m_fence_dist);
  AfxGetApp()->WriteProfileInt(_T("Event\\Fence"), _T("Enter"),     m_fence_enter);
  AfxGetApp()->WriteProfileInt(_T("Event\\Fence"), _T("Exit"),      m_fence_exit);

  // Create command VSMS
  req.Command   = 0x04;
  req.Latitude  = m_fence_lat;
  req.Longitude = m_fence_lon;
  req.Distance  = m_fence_dist;
  req.Enter     = m_fence_enter;
  req.Exit      = m_fence_exit;

  // Send VSMS
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set Geo-fence event"), MB_OK|MB_ICONWARNING);
}

void CPageActions::OnSetPosfreq()
{
  // Var
  CString EntName;
  FrameSetPosFreq req;
  int rc;

  // Update Registry
  UpdateData(TRUE);
  AfxGetApp()->WriteProfileInt(_T("Event\\Position"), _T("Frequency"), m_pos_freq);

  // Create command VSMS
  req.Command = 0x01;
  req.Period  = m_pos_freq;

  // Send VSMS
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set position event"), MB_OK|MB_ICONWARNING);
}

void CPageActions::OnSetPower()
{
  // Var
  CString EntName;
  FrameSetPower req;
  int          rc;

  // Update Registry
  UpdateData(TRUE);
  AfxGetApp()->WriteProfileInt(_T("Event\\Power"), _T("Internal"), m_power_int);
  AfxGetApp()->WriteProfileInt(_T("Event\\Power"), _T("External"), m_power_ext);

  // Create command VSMS
  req.Command   = 0x06;
  req.External  = m_power_ext;
  req.Internal  = m_power_int;

  // Send VSMS
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set power event"), MB_OK|MB_ICONWARNING);
}

void CPageActions::OnSetSpeed()
{
  // Var
  CString EntName;
  FrameSetSpeed req;
  int          rc;

  // Update Registry
  UpdateData(TRUE);
  AfxGetApp()->WriteProfileInt(_T("Event\\Speed"), _T("Limit"),    m_speed_limit);
  AfxGetApp()->WriteProfileInt(_T("Event\\Speed"), _T("HoldTime"), m_speed_hold);
  AfxGetApp()->WriteProfileInt(_T("Event\\Speed"), _T("Falling"),  m_speed_falling);
  AfxGetApp()->WriteProfileInt(_T("Event\\Speed"), _T("Raising"),  m_speed_raising);

  // Create command VSMS
  req.Command   = 0x05;
  req.Threshold = m_speed_limit * 10;
  req.Duration  = m_speed_hold;
  req.Above     = m_speed_raising;
  req.Below     = m_speed_falling;

  // Send VSMS
  if (vsmsgwSendPDU(AfxGetApp()->GetProfileInt(_T("Options"), _T("His nodeid"), 2001), (unsigned char*)&req, sizeof(req), &rc) || rc)
    MessageBox(_T("No responce from unit"), _T("Set speed event"), MB_OK|MB_ICONWARNING);
}

void CPageActions::OnTcnSelchangeTab(NMHDR *pNMHDR, LRESULT *pResult)
{
  // Result
  *pResult = 0;

  // Save old
  ViewToVar(m_Index);

  // Insert new
  m_Index = c_tab.GetCurSel();
  VarToView(m_Index);
}

void CPageActions::ViewToVar(const int tab)
{
  // Retreive
  UpdateData(TRUE);

  // Insert in struct
  m_Entry[tab].HoldTime = m_din_hold;
  m_Entry[tab].on       = m_din_on;
  m_Entry[tab].off      = m_din_off;
}

void CPageActions::VarToView(const int tab)
{
  // Insert from struct
  m_din_hold = m_Entry[tab].HoldTime;
  m_din_on   = m_Entry[tab].on;
  m_din_off  = m_Entry[tab].off;

  // Update dialog
  UpdateData(FALSE);
}
