// stdafx.h : include file for standard system include files,
// or project specific include files that are used frequently,
// but are changed infrequently

#pragma once

#ifndef _SECURE_ATL
#define _SECURE_ATL 1
#endif

#ifndef VC_EXTRALEAN
#define VC_EXTRALEAN		// Exclude rarely-used stuff from Windows headers
#endif

// Modify the following defines if you have to target a platform prior to the ones specified below.
// Refer to MSDN for the latest info on corresponding values for different platforms.
#ifndef WINVER				// Allow use of features specific to Windows XP or later.
#define WINVER 0x0501		// Change this to the appropriate value to target other versions of Windows.
#endif

#ifndef _WIN32_WINNT		// Allow use of features specific to Windows XP or later.                   
#define _WIN32_WINNT 0x0501	// Change this to the appropriate value to target other versions of Windows.
#endif						

#ifndef _WIN32_WINDOWS		// Allow use of features specific to Windows 98 or later.
#define _WIN32_WINDOWS 0x0410 // Change this to the appropriate value to target Windows Me or later.
#endif

#ifndef _WIN32_IE			// Allow use of features specific to IE 6.0 or later.
#define _WIN32_IE 0x0600	// Change this to the appropriate value to target other versions of IE.
#endif

#define _ATL_CSTRING_EXPLICIT_CONSTRUCTORS	// some CString constructors will be explicit

// turns off MFC's hiding of some common and often safely ignored warning messages
#define _AFX_ALL_WARNINGS

#include <afxwin.h>         // MFC core and standard components
#include <afxext.h>         // MFC extensions





#ifndef _AFX_NO_OLE_SUPPORT
#include <afxdtctl.h>		// MFC support for Internet Explorer 4 Common Controls
#endif
#ifndef _AFX_NO_AFXCMN_SUPPORT
#include <afxcmn.h>			// MFC support for Windows Common Controls
#endif // _AFX_NO_AFXCMN_SUPPORT
#include <afxdlgs.h>









#ifdef _UNICODE
#if defined _M_IX86
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='x86' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_IA64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='ia64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#elif defined _M_X64
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='amd64' publicKeyToken='6595b64144ccf1df' language='*'\"")
#else
#pragma comment(linker,"/manifestdependency:\"type='win32' name='Microsoft.Windows.Common-Controls' version='6.0.0.0' processorArchitecture='*' publicKeyToken='6595b64144ccf1df' language='*'\"")
#endif
#endif


#pragma pack (push, before)
#pragma pack(1)

struct FrameEventInfo {
  unsigned char  event_id;
  char           event_data;
  unsigned char  mode;
  long           date;
  long           time;
  long           lat;
  long           lon;
  short          direction;
  long           speed;
  short          supply;
};

struct FrameHostID {
  unsigned char  Command;
  unsigned long  NodeID;
};

struct FrameSetRoaming {
  unsigned char  Command;
  unsigned int   LAI[16];
};

struct FrameSetPowersave {
  unsigned char  Command;
  unsigned char  Ignition;
  unsigned char  Timeout;
  unsigned short GpsMove;
  unsigned char  Vibration;
  unsigned short PowersaveTime;
  unsigned char  Timer1StartHour;
  unsigned char  Timer1StartMin;
  unsigned char  Timer1StopHour;
  unsigned char  Timer1StopMin;
  unsigned char  Timer2StartHour;
  unsigned char  Timer2StartMin;
  unsigned char  Timer2StopHour;
  unsigned char  Timer2StopMin;
  unsigned char  Timer3StartHour;
  unsigned char  Timer3StartMin;
  unsigned char  Timer3StopHour;
  unsigned char  Timer3StopMin;
};

struct FrameSetInput {
  unsigned char  Command;
  unsigned char  Input;
  unsigned short Duration;
  unsigned char  Low;
  unsigned char  High;
};

struct FrameSetGeoFence {
  unsigned char  Command;
  long           Latitude;
  long           Longitude;
  unsigned long  Distance;
  unsigned char  Enter;
  unsigned char  Exit;
};

struct FrameSetPosFreq {
  unsigned char  Command;
  unsigned int   Period;
};

struct FrameSetPower {
  unsigned char  Command;
  unsigned char  External;
  unsigned char  Internal;
};

struct FrameSetSpeed {
  unsigned char  Command;
  unsigned short Threshold;
  unsigned short Duration;
  unsigned char  Above;
  unsigned char  Below;
};

struct FrameSetGPRS {
  unsigned char  Command;
  unsigned char  Index;
  unsigned int   Lai;
  unsigned int   Ip;
  unsigned int   Subnet;
  unsigned int   Gateway;
  unsigned int   DNS1;
  unsigned int   DNS2;
};

struct FrameSetGW {
  unsigned char  Command;
  unsigned char  Enable;
  unsigned int   Port;
  unsigned short MaxConn;
  unsigned short Retries;
  unsigned short Timeout;
  unsigned int   Alive;
};

union Frames {
  FrameSetGPRS   gprs;
  FrameSetGW     gw;
  char           data[140];
};


#pragma pack(pop, before)


const UINT UWM_UPDATE_WINDOW = RegisterWindowMessage(_T("UWM_UPDATE_WINDOW"));
